Index: src/UIElements/Query/AtomsQuery.cpp
===================================================================
--- src/UIElements/Query/AtomsQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/AtomsQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,7 +24,7 @@
 
 // Atoms Queries
-Dialog::AtomsQuery::AtomsQuery(std::string title, std::string _description) :
+Dialog::AtomsQuery::AtomsQuery(Parameter<std::vector<const atom *> > &param, std::string title, std::string _description) :
     Query(title, _description),
-    tmp(0)
+    tmp(param)
 {}
 
@@ -32,5 +32,5 @@
 
 void Dialog::AtomsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/BooleanQuery.cpp
===================================================================
--- src/UIElements/Query/BooleanQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/BooleanQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,7 +24,7 @@
 
 // Bool Queries
-Dialog::BooleanQuery::BooleanQuery(std::string title,std::string description) :
+Dialog::BooleanQuery::BooleanQuery(Parameter<bool> &param, std::string title,std::string description) :
     Query(title, description),
-    tmp(false)
+    tmp(param)
 {}
 
@@ -32,5 +32,5 @@
 
 void Dialog::BooleanQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/DoubleQuery.cpp
===================================================================
--- src/UIElements/Query/DoubleQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/DoubleQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,7 +24,7 @@
 
 // Double Queries
-Dialog::DoubleQuery::DoubleQuery(std::string title, std::string _description) :
+Dialog::DoubleQuery::DoubleQuery(Parameter<double> &param, std::string title, std::string _description) :
     Query(title, _description),
-    tmp(0)
+    tmp(param)
 {}
 
@@ -32,5 +32,5 @@
 
 void Dialog::DoubleQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/DoublesQuery.cpp
===================================================================
--- src/UIElements/Query/DoublesQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/DoublesQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // Doubles Queries
-Dialog::DoublesQuery::DoublesQuery(std::string title, std::string _description) :
-    Query(title, _description)
+Dialog::DoublesQuery::DoublesQuery(Parameter<std::vector<double> > &param, std::string title, std::string _description) :
+    Query(title, _description),
+    tmp(param)
 {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::DoublesQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/ElementQuery.cpp
===================================================================
--- src/UIElements/Query/ElementQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/ElementQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // Element Queries
-Dialog::ElementQuery::ElementQuery(std::string title, std::string _description) :
-  Query(title, _description)
+Dialog::ElementQuery::ElementQuery(Parameter<const element *> &param, std::string title, std::string _description) :
+  Query(title, _description),
+  tmp(param)
   {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::ElementQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/ElementsQuery.cpp
===================================================================
--- src/UIElements/Query/ElementsQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/ElementsQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // Elements Queries
-Dialog::ElementsQuery::ElementsQuery(std::string title, std::string _description) :
-  Query(title, _description)
+Dialog::ElementsQuery::ElementsQuery(Parameter<std::vector<const element *> > &param, std::string title, std::string _description) :
+  Query(title, _description),
+  tmp(param)
   {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::ElementsQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/FileQuery.cpp
===================================================================
--- src/UIElements/Query/FileQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/FileQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // File Queries
-Dialog::FileQuery::FileQuery(std::string title, std::string _description) :
-  Query(title, _description)
+Dialog::FileQuery::FileQuery(Parameter<boost::filesystem::path> &param, std::string title, std::string _description) :
+  Query(title, _description),
+  tmp(param)
   {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::FileQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/FilesQuery.cpp
===================================================================
--- src/UIElements/Query/FilesQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/FilesQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // File Queries
-Dialog::FilesQuery::FilesQuery(std::string title, std::string _description) :
-  Query(title, _description)
+Dialog::FilesQuery::FilesQuery(Parameter<std::vector< boost::filesystem::path> > &param, std::string title, std::string _description) :
+  Query(title, _description),
+  tmp(param)
   {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::FilesQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/IntQuery.cpp
===================================================================
--- src/UIElements/Query/IntQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/IntQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,7 +24,7 @@
 
 // Int Queries
-Dialog::IntQuery::IntQuery(std::string title, std::string description) :
+Dialog::IntQuery::IntQuery(Parameter<int> &param, std::string title, std::string description) :
     Query(title, description),
-    tmp(0)
+    tmp(param)
 {}
 
@@ -32,5 +32,5 @@
 
 void Dialog::IntQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/IntsQuery.cpp
===================================================================
--- src/UIElements/Query/IntsQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/IntsQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // Ints Queries
-Dialog::IntsQuery::IntsQuery(std::string title, std::string description) :
-    Query(title, description)
+Dialog::IntsQuery::IntsQuery(Parameter<std::vector<int> > &param, std::string title, std::string description) :
+    Query(title, description),
+    tmp(param)
 {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::IntsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/MoleculeQuery.cpp
===================================================================
--- src/UIElements/Query/MoleculeQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/MoleculeQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,7 +24,7 @@
 
 // Molecule Queries
-Dialog::MoleculeQuery::MoleculeQuery(std::string title, std::string _description) :
+Dialog::MoleculeQuery::MoleculeQuery(Parameter<const molecule *> &param, std::string title, std::string _description) :
     Query(title, _description),
-    tmp(0)
+    tmp(param)
 {}
 
@@ -32,5 +32,5 @@
 
 void Dialog::MoleculeQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/MoleculesQuery.cpp
===================================================================
--- src/UIElements/Query/MoleculesQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/MoleculesQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,7 +24,7 @@
 
 // Molecules Queries
-Dialog::MoleculesQuery::MoleculesQuery(std::string title, std::string _description) :
+Dialog::MoleculesQuery::MoleculesQuery(Parameter<std::vector<const molecule *> > &param, std::string title, std::string _description) :
     Query(title, _description),
-    tmp(0)
+    tmp(param)
 {}
 
@@ -32,5 +32,5 @@
 
 void Dialog::MoleculesQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/RandomNumberDistribution_ParametersQuery.cpp
===================================================================
--- src/UIElements/Query/RandomNumberDistribution_ParametersQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/RandomNumberDistribution_ParametersQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -23,6 +23,7 @@
 
 // RandomNumberDistribution_Parameters Queries
-Dialog::RandomNumberDistribution_ParametersQuery::RandomNumberDistribution_ParametersQuery(std::string title, std::string _description) :
-    Query(title, _description)
+Dialog::RandomNumberDistribution_ParametersQuery::RandomNumberDistribution_ParametersQuery(Parameter<RandomNumberDistribution_Parameters> &param, std::string title, std::string _description) :
+    Query(title, _description),
+    tmp(param)
 {}
 
@@ -30,5 +31,5 @@
 
 void Dialog::RandomNumberDistribution_ParametersQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/RealSpaceMatrixQuery.cpp
===================================================================
--- src/UIElements/Query/RealSpaceMatrixQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
+++ src/UIElements/Query/RealSpaceMatrixQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -0,0 +1,37 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * BoxQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// Box Queries
+Dialog::RealSpaceMatrixQuery::RealSpaceMatrixQuery(Parameter<RealSpaceMatrix> &param, std::string title, std::string _description) :
+  Query(title, _description),
+  tmp(param)
+{}
+
+Dialog::RealSpaceMatrixQuery::~RealSpaceMatrixQuery()
+{}
+
+void Dialog::RealSpaceMatrixQuery::setResult() {
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
Index: src/UIElements/Query/StringQuery.cpp
===================================================================
--- src/UIElements/Query/StringQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/StringQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // String Queries
-Dialog::StringQuery::StringQuery(std::string title,std::string _description) :
-    Query(title, _description)
+Dialog::StringQuery::StringQuery(Parameter<std::string> &param, std::string title,std::string _description) :
+    Query(title, _description),
+    tmp(param)
 {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::StringQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/StringsQuery.cpp
===================================================================
--- src/UIElements/Query/StringsQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/StringsQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // Strings Queries
-Dialog::StringsQuery::StringsQuery(std::string title,std::string _description) :
-    Query(title, _description)
+Dialog::StringsQuery::StringsQuery(Parameter<std::vector<std::string> > &param, std::string title,std::string _description) :
+    Query(title, _description),
+    tmp(param)
 {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::StringsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/UnsignedIntQuery.cpp
===================================================================
--- src/UIElements/Query/UnsignedIntQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/UnsignedIntQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,7 +24,7 @@
 
 // UnsignedInt Queries
-Dialog::UnsignedIntQuery::UnsignedIntQuery(std::string title, std::string description) :
+Dialog::UnsignedIntQuery::UnsignedIntQuery(Parameter<unsigned int> &param, std::string title, std::string description) :
     Query(title, description),
-    tmp(0)
+    tmp(param)
 {}
 
@@ -32,5 +32,5 @@
 
 void Dialog::UnsignedIntQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/UnsignedIntsQuery.cpp
===================================================================
--- src/UIElements/Query/UnsignedIntsQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/UnsignedIntsQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // UnsignedInts Queries
-Dialog::UnsignedIntsQuery::UnsignedIntsQuery(std::string title, std::string description) :
-    Query(title, description)
+Dialog::UnsignedIntsQuery::UnsignedIntsQuery(Parameter<std::vector<unsigned int> > &param, std::string title, std::string description) :
+    Query(title, description),
+    tmp(param)
 {}
 
@@ -31,5 +32,5 @@
 
 void Dialog::UnsignedIntsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/VectorQuery.cpp
===================================================================
--- src/UIElements/Query/VectorQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/VectorQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // Vector Queries
-Dialog::VectorQuery::VectorQuery(std::string title,bool _check, std::string _description) :
+Dialog::VectorQuery::VectorQuery(Parameter<Vector> &param, std::string title,bool _check, std::string _description) :
   Query(title, _description),
+  tmp(param),
   check(_check)
 {}
@@ -33,5 +34,5 @@
 
 void Dialog::VectorQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/Query/VectorsQuery.cpp
===================================================================
--- src/UIElements/Query/VectorsQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Query/VectorsQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,6 +24,7 @@
 
 // Vectors Queries
-Dialog::VectorsQuery::VectorsQuery(std::string title,bool _check, std::string _description) :
+Dialog::VectorsQuery::VectorsQuery(Parameter<std::vector<Vector> > &param, std::string title,bool _check, std::string _description) :
   Query(title, _description),
+  tmp(param),
   check(_check)
 {}
@@ -33,5 +34,5 @@
 
 void Dialog::VectorsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+  //ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
Index: src/UIElements/TextUI/Query/AtomTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/AtomTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/AtomTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -30,6 +30,6 @@
 #include "World.hpp"
 
-TextDialog::AtomTextQuery::AtomTextQuery(std::string title, std::string _description) :
-    Dialog::AtomQuery(title,_description)
+TextDialog::AtomTextQuery::AtomTextQuery(Parameter<const atom *> &param, std::string title, std::string _description) :
+    Dialog::AtomQuery(param, title,_description)
 {}
 
@@ -51,9 +51,10 @@
     }
 
-    tmp = World::getInstance().getAtom(AtomById(idxOfAtom));
-    if(!tmp && idxOfAtom!=-1){
+    const atom * temp_atom = World::getInstance().getAtom(AtomById(idxOfAtom));
+    if(!temp_atom && idxOfAtom!=-1){
       std::cout << "Invalid Atom Index" << idxOfAtom << std::endl;
       badInput = true;
     }
+    tmp.set(temp_atom);
 
   } while(badInput);
Index: src/UIElements/TextUI/Query/AtomsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/AtomsTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/AtomsTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 
-TextDialog::AtomsTextQuery::AtomsTextQuery(std::string title, std::string _description) :
-    Dialog::AtomsQuery(title,_description)
+TextDialog::AtomsTextQuery::AtomsTextQuery(Parameter<std::vector<const atom *> > &param, std::string title, std::string _description) :
+    Dialog::AtomsQuery(param, title,_description)
 {}
 
@@ -44,4 +44,5 @@
   // dissect by " "
   std::string::iterator olditer = line.begin();
+  std::vector<const atom *> temp_atoms;
   for(std::string::iterator iter = line.begin(); iter != line.end(); ++iter) {
     if (*iter == ' ') {
@@ -53,5 +54,5 @@
         break;
       }
-      tmp.push_back(temp);
+      temp_atoms.push_back(temp);
       olditer = iter;
     }
@@ -63,7 +64,8 @@
     if(!temp && idxOfAtom!=-1) {
       std::cout << "Invalid Atom Index" << idxOfAtom << std::endl;
-      tmp.push_back(temp);
+      temp_atoms.push_back(temp);
     }
   }
+  tmp.set(temp_atoms);
 
   return (idxOfAtom!=-1);
Index: src/UIElements/TextUI/Query/BooleanTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/BooleanTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/BooleanTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::BooleanTextQuery::BooleanTextQuery(std::string title, std::string _description) :
-    Dialog::BooleanQuery(title,_description)
+TextDialog::BooleanTextQuery::BooleanTextQuery(Parameter<bool> &param, std::string title, std::string _description) :
+    Dialog::BooleanQuery(param, title,_description)
 {}
 
@@ -42,7 +42,7 @@
     std::cin >> input;
     if ((input == 'y' ) || (input == 'Y')) {
-      tmp = true;
+      tmp.set(true);
     } else if ((input == 'n' ) || (input == 'N')) {
-      tmp = false;
+      tmp.set(false);
     } else {
       badInput=true;
Index: src/UIElements/TextUI/Query/DoubleTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/DoubleTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/DoubleTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::DoubleTextQuery::DoubleTextQuery(std::string title, std::string _description) :
-    Dialog::DoubleQuery(title,_description)
+TextDialog::DoubleTextQuery::DoubleTextQuery(Parameter<double> &param, std::string title, std::string _description) :
+    Dialog::DoubleQuery(param, title,_description)
 {}
 
@@ -38,6 +38,7 @@
   do{
     badInput = false;
-    std::cout << getDescription() << ": ";
-    std::cin >> tmp;
+    std::cout << getDescription() << ": ";\
+    double temp_double;
+    std::cin >> temp_double;
     if(std::cin.fail()){
       badInput = true;
@@ -46,4 +47,5 @@
       std::cout << "Input was not a number!" << std::endl;
     }
+    tmp.set(temp_double);
   }while(badInput);
   std::cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
Index: src/UIElements/TextUI/Query/DoublesTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/DoublesTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/DoublesTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::DoublesTextQuery::DoublesTextQuery(std::string title, std::string _description) :
-    Dialog::DoublesQuery(title,_description)
+TextDialog::DoublesTextQuery::DoublesTextQuery(Parameter<std::vector<double> > &param, std::string title, std::string _description) :
+    Dialog::DoublesQuery(param, title,_description)
 {}
 
@@ -40,9 +40,10 @@
   // dissect by " "
   std::string::iterator olditer = line.begin();
+  std::vector<double> temp_doubles;
   for(std::string::iterator iter = line.begin(); iter != line.end(); ++iter) {
     if (*iter == ' ') {
       std::istringstream stream(std::string(iter, olditer));
       stream >> temp;
-      tmp.push_back(temp);
+      temp_doubles.push_back(temp);
       olditer = iter;
     }
@@ -51,6 +52,7 @@
     std::istringstream stream(std::string(olditer, line.end()));
     stream >> temp;
-    tmp.push_back(temp);
+    temp_doubles.push_back(temp);
   }
+  tmp.set(temp_doubles);
 
   return true;
Index: src/UIElements/TextUI/Query/ElementTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/ElementTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/ElementTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 
-TextDialog::ElementTextQuery::ElementTextQuery(std::string title, std::string _description) :
-    Dialog::ElementQuery(title,_description)
+TextDialog::ElementTextQuery::ElementTextQuery(Parameter<const element *> &param, std::string title, std::string _description) :
+    Dialog::ElementQuery(param, title,_description)
 {}
 
Index: src/UIElements/TextUI/Query/ElementsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/ElementsTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/ElementsTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -35,6 +35,6 @@
 
 
-TextDialog::ElementsTextQuery::ElementsTextQuery(std::string title, std::string _description) :
-    Dialog::ElementsQuery(title,_description)
+TextDialog::ElementsTextQuery::ElementsTextQuery(Parameter<std::vector<const element *> > &param, std::string title, std::string _description) :
+    Dialog::ElementsQuery(param, title,_description)
 {}
 
@@ -50,4 +50,5 @@
   // dissect by " "
   std::string::iterator olditer = line.begin();
+  std::vector<const element *> temp_elements;
   for(std::string::iterator iter = line.begin(); iter != line.end(); ++iter) {
     if (*iter == ' ') {
@@ -64,5 +65,5 @@
         break;
       }
-      tmp.push_back(temp);
+      temp_elements.push_back(temp);
       olditer = iter;
     }
@@ -79,7 +80,8 @@
     if(!temp && Z!=-1) {
       std::cout << "Invalid Element" << shorthand << std::endl;
-      tmp.push_back(temp);
+      temp_elements.push_back(temp);
     }
   }
+  tmp.set(temp_elements);
 
   return (Z!=-1);
Index: src/UIElements/TextUI/Query/FileTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/FileTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/FileTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 
-TextDialog::FileTextQuery::FileTextQuery(std::string title, std::string _description) :
-    Dialog::FileQuery(title,_description)
+TextDialog::FileTextQuery::FileTextQuery(Parameter<boost::filesystem::path> &param, std::string title, std::string _description) :
+    Dialog::FileQuery(param, title,_description)
 {}
 
@@ -48,10 +48,10 @@
       std::cin.clear();
       std::cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      std::cout << "Input was not a number!" << std::endl;
+      std::cout << "Input was not a file!" << std::endl;
       continue;
     }
   } while(badInput);
   std::cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  tmp = tempstring;
+  tmp.set(tempstring);
   return true;
 }
Index: src/UIElements/TextUI/Query/FilesTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/FilesTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/FilesTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 
-TextDialog::FilesTextQuery::FilesTextQuery(std::string title, std::string _description) :
-    Dialog::FilesQuery(title,_description)
+TextDialog::FilesTextQuery::FilesTextQuery(Parameter<std::vector< boost::filesystem::path> > &param, std::string title, std::string _description) :
+    Dialog::FilesQuery(param, title,_description)
 {}
 
@@ -38,25 +38,32 @@
 
 bool TextDialog::FilesTextQuery::handle() {
-  std::string tempstring;
-  boost::filesystem::path tempfile;
-  do{
-    std::cout << getDescription() << ": ";
+  std::vector<boost::filesystem::path> tempfiles;
+  bool badInput = false;
+  bool continueflag = true;
+  do {
+    std::string tempstring;
+    do{
+      badInput = false;
+      std::cout << getDescription() << ": ";
+      std::cin >> tempstring;
+      if(std::cin.fail()){
+        badInput = true;
+        std::cin.clear();
+        std::cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+        std::cout << "Input was not a valid file!" << std::endl;
+        continue;
+      }
+    } while(badInput);
+    boost::filesystem::path tempfile;
+    tempfile = tempstring;
+    std::cout << "Enter another file [y/n]? ";
     std::cin >> tempstring;
-    if (std::cin.fail()) {
-      std::cin.clear();
-      std::cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-      std::cout << "Input was not a valid string!" << std::endl;
-      continue;
-    }
-    tempfile = tempstring;
-    if (boost::filesystem::exists(tempfile)) {
-      tmp.push_back(tempfile);
-    } else {
-      ELOG(1, "File " << tempstring << " cannot be found.");
-      tempstring = std::string();
-    }
-  } while(tempstring != std::string());
+    if (tempstring != "y")
+      continueflag = false;
+    tempfiles.push_back(tempfile);
+  } while(continueflag);
   std::cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
-  return !tmp.empty();
+  tmp.set(tempfiles);
+  return true;
 }
 
Index: src/UIElements/TextUI/Query/IntTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/IntTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/IntTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::IntTextQuery::IntTextQuery(std::string title, std::string _description) :
-    Dialog::IntQuery(title,_description)
+TextDialog::IntTextQuery::IntTextQuery(Parameter<int> &param, std::string title, std::string _description) :
+    Dialog::IntQuery(param, title,_description)
 {}
 
@@ -39,5 +39,7 @@
     badInput = false;
     std::cout << getDescription() << ": ";
-    std::cin >> tmp;
+    int temp_int;
+    std::cin >> temp_int;
+    tmp.set(temp_int);
     if(std::cin.fail()){
       badInput=true;
Index: src/UIElements/TextUI/Query/IntsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/IntsTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/IntsTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,6 +28,6 @@
 
 
-TextDialog::IntsTextQuery::IntsTextQuery(std::string title, std::string _description) :
-    Dialog::IntsQuery(title,_description)
+TextDialog::IntsTextQuery::IntsTextQuery(Parameter<std::vector<int> > &param, std::string title, std::string _description) :
+    Dialog::IntsQuery(param, title,_description)
 {}
 
@@ -39,4 +39,5 @@
   getline(std::cin,line);
   // dissect by " "
+  std::vector<int> temp_int;
   std::string::iterator olditer = line.begin();
   for(std::string::iterator iter = line.begin(); iter != line.end(); ++iter) {
@@ -44,5 +45,5 @@
       std::istringstream stream(std::string(iter, olditer));
       stream >> temp;
-      tmp.push_back(temp);
+      temp_int.push_back(temp);
       olditer = iter;
     }
@@ -51,6 +52,7 @@
     std::istringstream stream(std::string(olditer, line.end()));
     stream >> temp;
-    tmp.push_back(temp);
+    temp_int.push_back(temp);
   }
+  tmp.set(temp_int);
 
   return true;
Index: src/UIElements/TextUI/Query/MoleculeTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/MoleculeTextQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/TextUI/Query/MoleculeTextQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,6 +31,6 @@
 
 
-TextDialog::MoleculeTextQuery::MoleculeTextQuery(std::string title, std::string _description) :
-    Dialog::MoleculeQuery(title,_description)
+TextDialog::MoleculeTextQuery::MoleculeTextQuery(Parameter<const molecule *> &param, std::string title, std::string _description) :
+    Dialog::MoleculeQuery(param, title,_description)
 {}
 
@@ -52,9 +52,10 @@
     }
 
-    tmp = World::getInstance().getMolecule(MoleculeById(idxOfMol));
-    if(!tmp && idxOfMol!=-1){
+    const molecule *temp_mol = World::getInstance().getMolecule(MoleculeById(idxOfMol));
+    if(!temp_mol && idxOfMol!=-1){
       std::cout << "Invalid Molecule Index" << std::endl;
       badInput = true;
     }
+    tmp.set(temp_mol);
 
   } while(badInput);
